/*****************************************************************************
 *  FTools - Freenet Client Protocol Tools
 *
 *  Copyright (C) 2002 Juergen Buchmueller <juergen@pullmoll.de>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *****************************************************************************/
#ifndef	_ftfcp_h
#define	_ftfcp_h

#include "ftsock.h"

typedef struct fcp_s {
	conn_t	conn;

	char *uri;
	char *public_key;
	char *private_key;

	size_t metasize, metaoffs;
	char *meta;

	size_t datasize, dataoffs;
	char *data;

	int	seen_node_hello;
	char *seen_protocol;
	char *seen_node;
	int	seen_end_message;

	int	seen_data_found;
	int	seen_uri_error;
	int	seen_restarted;
	int	seen_data_not_found;
	int	seen_route_not_found;

	int	seen_data_chunk;
	int	seen_length;
	int	seen_data;
	int	seen_data_complete;

	int seen_success;
	int seen_pending;
	int seen_key_collision;
	int seen_size_error;

}	fcp_t;

#ifdef	__cplusplus
extern "C" {
#endif
int fcp_new(fcp_t **pf, const char *hostname, int port);
int fcp_free(fcp_t **pf);
int fcp_hello(fcp_t *f);
int fcp_key(fcp_t *f);
int fcp_get(fcp_t *f, const char *uri, int htl);
int fcp_put(fcp_t *f, const char *uri, int htl, int delete_local);
int fcp_chk(fcp_t *f);
int fcp_del(fcp_t *f, const char *uri);
#ifdef	__cplusplus
}		/* extern "C" */
#endif

#endif	/* _ftfcp_h */
