/* This function is based on the GNU/Linux man page timegm(3).  But I changed
   setenv() to putenv().  And there's no unsetenv() equivalent.... */

#include <time.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>

time_t my_timegm (struct tm *tm) {
	time_t ret;
	char *tz;

	tz = getenv ("TZ");
	if (putenv ("TZ=") != 0) return -1;
	tzset();
	ret = mktime (tm);
	if (tz) {
		char *s;
		int r;

		if ((s = malloc (strlen (tz) + 4)) == NULL) return -1;
		sprintf (s, "TZ=%s", tz);
		r = putenv (s);
		free (s);
		if (r != 0) return -1;
	} else {
		if (putenv ("TZ=") != 0) return -1;
	}
	tzset();
	return ret;
}
